{ ... }:
{
  disko-root-lvm =
    {
      diskName,
      device,
      espSize ? "500M",
      bootPartName ? "ESP",
      rootPartName ? "primary",
      volumeGroupName ? "mainpool",
      rootLvName ? "root",
    }:
    {
      devices.disk = {
        "${diskName}" = {
          inherit device;
          type = "disk";
          content = {
            type = "gpt";
            partitions = {
              "${bootPartName}" = {
                size = espSize;
                type = "EF00";
                content = {
                  type = "filesystem";
                  format = "vfat";
                  mountpoint = "/boot";
                  mountOptions = [ "umask=0077" ];
                };
              };
              "${rootPartName}" = {
                size = "100%";
                content = {
                  type = "lvm_pv";
                  vg = volumeGroupName;
                };
              };
            };
          };
        };
      };
      devices.lvm_vg = {
        "${volumeGroupName}" = {
          type = "lvm_vg";
          lvs = {
            "${rootLvName}" = {
              size = "100%";
              content = {
                type = "filesystem";
                format = "ext4";
                mountpoint = "/";
                mountOptions = [ "defaults" ];
              };
            };
          };
        };
      };
    };
}
